import Hookable from 'hookable';
import type { NuxtHTTPInstance } from '@nuxt/http';
import type { NuxtCookies } from 'cookie-universal-nuxt';
import type { NuxtStrapiEmailData, NuxtStrapiLoginData, NuxtStrapiLoginResult, NuxtStrapiQueryParams, NuxtStrapiRegistrationData, NuxtStrapiResetPasswordData, NuxtStrapiUser, StrapiOptions } from './types';
export declare class Strapi extends Hookable {
    private state;
    $cookies: NuxtCookies;
    $http: NuxtHTTPInstance;
    options: StrapiOptions;
    $refreshTimer: any;
    constructor(ctx: any, options: StrapiOptions);
    get user(): NuxtStrapiUser;
    set user(user: NuxtStrapiUser);
    register(data: NuxtStrapiRegistrationData): Promise<NuxtStrapiLoginResult>;
    login(data: NuxtStrapiLoginData): Promise<NuxtStrapiLoginResult>;
    forgotPassword(data: NuxtStrapiEmailData): Promise<unknown>;
    resetPassword(data: NuxtStrapiResetPasswordData): Promise<NuxtStrapiLoginResult>;
    sendEmailConfirmation(data: NuxtStrapiEmailData): Promise<unknown>;
    logout(): Promise<void>;
    fetchUser(): Promise<NuxtStrapiUser>;
    refreshToken(): Promise<NuxtStrapiLoginResult>;
    setUser(user: any): Promise<void>;
    find<T = any, E = string>(entity: E, searchParams?: NuxtStrapiQueryParams): Promise<T>;
    count<T = any, E = string>(entity: E, searchParams?: NuxtStrapiQueryParams): Promise<T>;
    findOne<T = any, E = string>(entity: E, id: string): Promise<T>;
    create<T = any, E = string>(entity: E, data: NuxtStrapiQueryParams): Promise<T>;
    update<T = any, E = string>(entity: E, id: string, data: NuxtStrapiQueryParams): Promise<T>;
    delete<T = any, E = string>(entity: E, id: string): Promise<T>;
    graphql<T = any>(query: any): Promise<T>;
    private getClientStorage;
    getToken(): string;
    setToken(token: string): void;
    clearToken(): void;
    private syncToken;
    getRefreshToken(): string;
    setRefreshToken(token: string): void;
    clearRefreshToken(): void;
    _refreshTokenKey(key: any): string;
    _startTokenRefreshTimer(): void;
    _stopTokenRefreshTimer(): void;
}
